﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class MenuAnimations : MonoBehaviour {

	public Image logoImage;
	public Image newGameImage;
	public Image highScoresImage;
	public Image optionsImage;
	public Image helpImage;
	public Image volumeImage;

    public Image buyProImage;

    public Text loggedInText;

	public Image overlayImage;
	public GameObject overlayObject;
	public float overlayOpacity = 0.0f;

	public bool fadeIn = false;
	public bool fadeOut = false;
	public bool nextPage = false;
	public float curAlpha = 0.0f;

	public float animSpeed = 0.5f;

	public bool startGame = false;

	public MenuManager menuManager;

    public Vector3 origNewGame;
    public Vector3 origHighScores;
    public Vector3 origOptions;
    public Vector3 origHelp;

    public float curNewGame;
    public float curHighScores;
    public float curOptions;
    public float curHelp;

    public bool beginSlideIn = false;
    public bool endSlideIn = false;

    public int curSlide = 0;

     float slideAmt = 5.0f;
     float slideSpeed= 0.6f;

    public bool freeMode = false;

   // public UniWebView likeWebView;

	// Use this for initialization
	void Start () {

        PlayerPrefs.DeleteAll();

        freeMode = true;

        PlayerPrefs.SetInt("free_mode", 0);

        slideAmt -= slideSpeed;

        slideButtonsIn();

		updateColor();
		overlayObject.SetActive(false);

    //    likeWebView.BackgroundColor = Color.clear;

	}

    public void slideButtonsIn() {
        
        origNewGame = newGameImage.transform.position;
        origHighScores = highScoresImage.transform.position;
        origOptions = optionsImage.transform.position;
        origHelp = helpImage.transform.position;

       // newGameImage.transform.position = new Vector3(0.0f, origNewGame.y);
       // highScoresImage.transform.position = new Vector3(0.0f, origHighScores.y);
        //optionsImage.transform.position = new Vector3(0.0f, origOptions.y);
        //helpImage.transform.position = new Vector3(0.0f, origHelp.y);

        //curNewGame =  slideAmt;
        //curHighScores = slideAmt;
        //curOptions = slideAmt;
        //curHelp =  slideAmt;

        newGameImage.transform.position = new Vector3(slideAmt,origNewGame.y);
        highScoresImage.transform.position = new Vector3(slideAmt, origHighScores.y);
        optionsImage.transform.position = new Vector3(slideAmt, origOptions.y);
        helpImage.transform.position = new Vector3(slideAmt, origHelp.y);

        beginSlideIn = true;
        curSlide = 1;

    }

    public void handleSlide () {
        if (beginSlideIn && curSlide == 1) {
         
            if (newGameImage.transform.position.x > origNewGame.x)
            {
                float position = newGameImage.transform.position.x;
                position -= slideSpeed;
                newGameImage.transform.position = new Vector3(position, origNewGame.y);
            }
            else { 
                newGameImage.transform.position = new Vector3(origNewGame.x, origNewGame.y);
                curSlide = 2;
            }
        } else if (beginSlideIn && curSlide == 2)
        {

            if (highScoresImage.transform.position.x > origHighScores.x)
            {
                float position = highScoresImage.transform.position.x;
                position -= slideSpeed;
                highScoresImage.transform.position = new Vector3(position, origHighScores.y);
            }
            else
            {
                curSlide = 3;
                highScoresImage.transform.position = new Vector3(origHighScores.x, origHighScores.y);
            }
        }
        else if (beginSlideIn && curSlide == 3)
        {

            if (optionsImage.transform.position.x > origOptions.x)
            {
                float position = optionsImage.transform.position.x;
                position -= slideSpeed;
                optionsImage.transform.position = new Vector3(position, origOptions.y);
            }
            else
            {
                optionsImage.transform.position = new Vector3(origOptions.x, origOptions.y);
                curSlide = 4;
            }
        }
        else if (beginSlideIn && curSlide == 4)
        {

            if (helpImage.transform.position.x > origHelp.x)
            {
                float position = helpImage.transform.position.x;
                position -= slideSpeed;
                helpImage.transform.position = new Vector3(position, origHelp.y);
            }
            else
            {
                helpImage.transform.position = new Vector3(origHelp.x, origHelp.y);
                curSlide = 5;
            }
        }

    }

	public void startNewGame () {


		overlayOpacity = 0.0f;
		Color tmpCol = overlayImage.color;
		tmpCol.a = overlayOpacity;
		overlayImage.color = tmpCol;
		overlayObject.SetActive(true);
		startGame = true;

	}

	// Update is called once per frame
	void Update () {

        if(beginSlideIn) {
            handleSlide();
        }

		if(startGame && overlayOpacity < 1.0f) {

			overlayOpacity += 0.05f;
			Color tmpCol = overlayImage.color;
			tmpCol.a = overlayOpacity;
			overlayImage.color = tmpCol;

		} else if(startGame && !(overlayOpacity < 1.0f)){

            startGame = false;
            SceneManager.LoadScene("02 - Game Scene",LoadSceneMode.Single);
            //Application.LoadLevel("02 - Game Scene");

		}

		if(fadeIn && curAlpha < 1.0f) { 

			curAlpha += 0.1f;

			updateColor();
		
		} else if(fadeOut && curAlpha > 0.0f) {

			curAlpha -= 0.1f;

			updateColor();

		}  else if(fadeOut && !(curAlpha > 0.0f)){

			fadeOut = false;
			nextPage = true;

		} else if(fadeIn && !(curAlpha < 1.0f)) {

			fadeIn = false;

		}

	}

	public void returnToMenu() {

		curAlpha = 0.0f;
		nextPage = false;
		fadeIn = true;

		menuManager.highScoresObject.SetActive(false);
		menuManager.optionsObject.SetActive(false);
		menuManager.helpObject.SetActive(false);

	}

	public void updateColor() {
		
		Color tmpCol = logoImage.color;
		tmpCol.a = curAlpha;
		logoImage.color = tmpCol;

		tmpCol = newGameImage.color;
		tmpCol.a = curAlpha;
		newGameImage.color = tmpCol;

		tmpCol = highScoresImage.color;
		tmpCol.a = curAlpha;
		highScoresImage.color = tmpCol;

		tmpCol = optionsImage.color;
		tmpCol.a = curAlpha;
		optionsImage.color = tmpCol;

		tmpCol = helpImage.color;
		tmpCol.a = curAlpha;
		helpImage.color = tmpCol;

		tmpCol = volumeImage.color;
		tmpCol.a = curAlpha;
		volumeImage.color = tmpCol;

   //     tmpCol = loggedInText.color;
        //tmpCol.a = curAlpha;
        //loggedInText.color = tmpCol;

        //tmpCol = likeImage.color;
        //tmpCol.a = curAlpha;
        //likeImage.color = tmpCol;

        //tmpCol = buyProImage.color;
        //tmpCol.a = curAlpha;
        //buyProImage.color = tmpCol;

	}
}
