﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class OnsetTop : MonoBehaviour {

	public Image onsetImage;
	public Text onsetText;
	public Text valueText;

	public bool visible = false;
	public bool shouldShow = false;
	public bool shouldHide = false;

	public float alpha = 0.0f;

	public GameController gameController;

	// Use this for initialization
	void Start () {

		gameController = GameObject.FindGameObjectWithTag("game_controller").GetComponent<GameController>();

		Color tempColor = onsetImage.color;
		tempColor.a = alpha;
		onsetImage.color = tempColor;

		tempColor = onsetText.color;
		tempColor.a = alpha;
		onsetText.color = tempColor;

		tempColor = valueText.color;
		tempColor.a = alpha;
		valueText.color = tempColor;

	}

	// Update is called once per frame
	void Update () {

        if (!gameController.onsetPressed && !shouldShow && !shouldHide && gameController.footerTime < 0)
        {
            visible = false;
        }


        if(gameController.onsetPressed && !visible) {
            shouldShow = true;
            shouldHide = false;
        }

		if(alpha < 1.0f && shouldShow && !visible){

			alpha += 0.1f;

			Color tempColor = onsetImage.color;
			tempColor.a = alpha;
			onsetImage.color = tempColor;

			tempColor = onsetText.color;
			tempColor.a = alpha;
			onsetText.color = tempColor;

			tempColor = valueText.color;
			tempColor.a = alpha;
			valueText.color = tempColor;

		} else if(!(alpha < 1.0f) && shouldShow && !visible){
			visible = true;
			shouldShow = false;
		}

		if(alpha > 0.0f && shouldHide && visible){

			alpha -= 0.1f;

			Color tempColor = onsetImage.color;
			tempColor.a = alpha;
			onsetImage.color = tempColor;

			tempColor = onsetText.color;
			tempColor.a = alpha;
			onsetText.color = tempColor;

			tempColor = valueText.color;
			tempColor.a = alpha;
			valueText.color = tempColor;

		} else if(!(alpha > 0.0f) && shouldHide && visible){
			visible = false;
			shouldHide = false;
		}

        if(!visible&&!shouldHide&&!shouldShow) {
            alpha = 0;
            Color tempColor = onsetImage.color;
            tempColor.a = alpha;
            onsetImage.color = tempColor;

            tempColor = onsetText.color;
            tempColor.a = alpha;
            onsetText.color = tempColor;

            tempColor = valueText.color;
            tempColor.a = alpha;
            valueText.color = tempColor;
        }

	}
}
